<?php
/**
 * Copy Right 99AIJIA.COM
 * Each engineer has a duty to keep the code elegant
 * $Id: index.ctl.php 14351 2015-07-22 01:25:14Z wanglei $
 */

if(!defined('__CORE_DIR')){
    exit("Access Denied");
}

class Ctl_Mobile_Passport extends Ctl_Mobile
{
    public function index()
    {
        $this->login();
    }
    
    public function login()
    {
        if (!empty($_SERVER['HTTP_REFERER']) && strstr($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) && !strstr($_SERVER['HTTP_REFERER'], 'passport')) {
            $backurl = $_SERVER['HTTP_REFERER'];
        } else {
            $backurl = '/mobile/index';
        }
        

        $yzm_config = $this->system->config->get('access');

        if($yzm_config['verifycode']['reg'] == 'on'){
            $this->pagedata['reg_yzm'] = $yzm_config['verifycode']['reg']; 
        }

        
        $this->pagedata['backurl'] = $backurl;        
        if($this->uid){
            $this->tmpl = 'mobile/index.html';
        }else{
            $this->tmpl = 'mobile/passport/login.html';
        }        
    }
    
    //微信登录
    public function wxlogin()
    {
        // 已授权
        if($wx_openid = $this->token_openid()){
            // 已绑定
            if($member = K::M('member/member')->member($wx_openid, 'wx_openid')){
                $ret = $this->system->auth->manager($member['uid']);
                header("Location:".$this->mklink('mobile/member/index'));
                exit;
            }else if($this->uid){
                // 需要绑定
                K::M('member/member')->update($this->uid, array('wx_openid'=>$wx_openid));
                header("Location:".$this->mklink('mobile/member/index'));
                exit;
            }else{
                header("Location:".$this->mklink('passport/wxbinding'));
            }
        }else{
            $this->msgbox->add('授权获取失败', 211);
        }
    }
    
    
    //微信绑定
    public function wxbind()
    {
        $data = array();
        if(!$wx_openid = $this->token_openid()){
            $this->wxlogin();
        }else if(!empty($_POST)){
            if(!$mobile = K::M('verify/check')->mobile($this->GP('mobile'))){
                $this->err->add('手机号不正确', 211);
            }else if(!$sms_code = $this->GP('mobile_yzm')){
                $this->err->add('验证码不能为空', 212);
            }else if(K::M('system/session')->start()->get('code_'.$mobile) != $sms_code){
                $this->err->add('验证码不正确', 213);
            }else if($member = K::M('member/member')->member($mobile, 'mobile')){
                K::M('member/member')->update($member['uid'], array('wx_openid'=>$wx_openid));
                $this->system->auth->manager($member['uid']);
                $this->err->add('绑定成功');
            }else{
                $data['mobile'] = $mobile;
                $data['wx_openid'] = $wx_openid;
                $data['paypasswd'] = $data['passwd'] = md5(uniqid());
                $data['nickname'] = substr($mobile, 0,3).'****'.substr($mobile, -4);
                if($uid = K::M('member/account')->create($data)){
                    if($this->system->auth->manager($uid)){
                        $this->err->add('绑定成功');
                    }
                }
            }
        }
    }
    //微信绑定
    public function wxbinding()
    {
        $this->tmpl = 'mobile/passport/wxbind.html';
    }
    
    public function sendsms()
	{
         if(isset($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest'){
             $phone = $this->GP('mobile');
             
              if(!$a = K::M('verify/check')->mobile($phone)){
                    $this->err->add('电话号码有误', 212);
                }else{
                    $code = rand(100000,999999);
                    $session =K::M('system/session')->start();
                    $session->set('code_'.$phone, $code,900); //15分钟缓存
                    $smsdata =  array('code'=>$code);
                    if(K::M('sms/smsbao')->send($phone, $smsdata)){
                        $this->err->add('信息发送成功');
                    }else{
                        $this->err->add('信息发送失败'.$code, 213);
                    }
               }
         }else{
             $this->error(404);
         }
	}


    public function handle($phone=null,$yzm=null,$yzm_val=null)
    {
        $session =K::M('system/session')->start();
        
        $yzm_config = $this->system->config->get('access');

        if($yzm_config['verifycode']['reg'] == 'on'){
            if(!$yzm_val){
                $this->err->add('网页安全验证码没有填写', 212);
                return false;
            }else if(!K::M('magic/verify')->check($yzm_val)){
                $this->err->add('网页安全验证码不正确', 212);
                return false;
            }
        }
        

        if(!$a = K::M('verify/check')->mobile($phone)){
            $this->err->add('电话号码有误', 212);
        }else if(!$yzm){
            $this->err->add('手机验证码错误',212);
        }else if(!($_SESSION['code_'.$phone]) || $yzm != $_SESSION['code_'.$phone]){
            $this->err->add('手机验证码错误或已过期',212);
        }else if($member = K::M('member/member')->member($phone, 'mobile')){
            if($member = $this->auth->manager($member['uid'])){                
                $this->err->add("欢迎您回来!".$a);
            }
        }else{
            $data['mobile'] = $phone;
            $data['passwd'] = uniqid();
            $data['paypasswd'] = uniqid();
            $data['nickname'] = '';
            if(defined('WX_OPENID')){
                $data['wx_openid'] = WX_OPENID;
                if($wx_info = $this->wechat_client()->getUserInfoById(WX_OPENID)){
                    $data['nickname'] = $wx_info['nickname'];
                }
            }
            if($member = K::M('member/member')->member($phone, 'mobile')){
                $this->err->add('该手机号码已经被注册', 213);
            }else if($uid = K::M('member/account')->create($data)){
                K::M('system/logs')->log('passport', $this->system->db->SQLLOG());
                $this->err->add('恭喜您，注册会员成功，请修改您的密码方便下次登录!');
                $this->err->set_data('forward', 'mobile/member/set/modifypwd.html');
            }
        }
	}
    
    public function handle2($phone=null,$password=null)
	{
        if(!$a = K::M('verify/check')->mobile($phone)){
            $this->err->add('电话号码有误', 212);
        }else if(!$password){
            $this->err->add('密码没有填写',213);
        }else if($member = K::M('member/member')->find(array('mobile'=>$phone))){
            if($member['passwd'] == md5($password)){
                if($member = $this->auth->manager($member['uid'])){
                    $this->err->add("欢迎您回来!");
                }
            }else{
                $this->err->add("密码错误!",215);
            }
            
        }else{
          $this->err->add("不存在!",214);
        }
	}
    

    public function loginout()
    {
       $this->auth->loginout();
        $url = K::M('helper/link')->mklink('index');
        header('Location:'.$url);
    }

}